/**
 * Java SendMail
 * Copyright (C) 2005  Ondrej Vondra
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package attachments;

public class cBase64Encoder {
  static byte basis_64[] =
      {'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q',
      'R','S','T','U','V','W','X','Y','Z',
      'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q',
      'r','s','t','u','v','w','x','y','z',
      '0','1','2','3','4','5','6','7','8','9','+','/'};

  static String encode(int max3bytes[]) // always returns 4 chars
  {
    if ( (max3bytes.length < 1) || (max3bytes.length > 3))
      return null;

    char r[] = new char[4];
    int c1, c2, c3;

    c1 = max3bytes[0];
    r[0] = (char) basis_64[c1 >> 2];

    switch (max3bytes.length)
    {
      case 3:
        c2 = max3bytes[1];
        c3 = max3bytes[2];

        r[1] = (char) basis_64[( (c1 & 0x3) << 4) | ( (c2 & 0xF0) >> 4)];
        r[2] = (char) basis_64[( (c2 & 0xF) << 2) | ( (c3 & 0xC0) >> 6)];
        r[3] = (char) basis_64[c3 & 0x3F];

        break;
      case 2:
        c2 = max3bytes[1];

        r[1] = (char) basis_64[( (c1 & 0x3) << 4) | ( (c2 & 0xF0) >> 4)];
        r[2] = (char) basis_64[(c2 & 0xF) << 2];
        r[3] = '=';

        break;
      default: // 1
        r[1] = (char) basis_64[(c1 & 0x3) << 4];
        r[2] = r[3] = '=';
    }
    return new String(r);
  }
}