/**
 * Java SendMail
 * Copyright (C) 2005  Ondrej Vondra
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 * cTerminalReader reads characters from stdin until it receives a line
 * containing only a dot "."
 */

package sendmail;

import java.io.*;
import sugar.Sys;

public class cTerminalReader extends InputStream {
  private byte currentLine[] = null;
  private int currentLineI = 0;
  private boolean readingended = false;

  private boolean readNextLine()
  {
    String l = Sys.readLine();
    if (l == null)
      return false;

    if (l.equals("."))
    {
      readingended = true;
      return false;
    }

    l+=System.getProperty("line.separator");

    currentLine = l.getBytes();
    currentLineI = 0;

    return true;
  }

  public int read() throws java.io.IOException {
    if (readingended)
      return -1;
    if ((currentLine==null) || (currentLineI == currentLine.length))
    {
      if (!readNextLine())
        return -1;
    }

    return currentLine[currentLineI++];
  }
}